=== debian/changelog ===
linux-lowlatency (3.8.0-4.3) raring; urgency=low

  [ Andy Whitcroft ]

  * [Config] add a build dependancy on openssl
  * rebase to Ubuntu-3.8.0-4.9

  [ Ubuntu: 3.8.0-4.9 ]

  * d-i: Add mellanox ethernet drivers to nic-modules
    - LP: #1015339
  * SAUCE: ACPI: Add DMI entry for Sony VGN-FW41E_H
    - LP: #1113547
  * SAUCE: alx driver import script
  * SAUCE: alx: Update to heads/master
  * Release Tracking Bug
    - LP: #1117673
  * [debian] Remove dangling symlink from headers package
    - LP: #1112442
  * [config] CONFIG_ALX=m
  * [Config] Add alx to d-i nic-modules
  * [Config] CONFIG_SATA_AHCI=m
    - LP: #1056563

 -- Andy Whitcroft <apw@canonical.com>  Thu, 07 Feb 2013 16:03:16 +0000
