## linux-lowlatency 3.8.0-6.4

=== debian/changelog ===
linux-lowlatency (3.8.0-6.4) raring; urgency=low

  [ Andy Whitcroft ]

  * rebase to Ubuntu-3.8.0-6.11

  [ Ubuntu: 3.8.0-6.11 ]

  * Release Tracking Bug
    - LP: #1122071
  * rebase to v3.8-rc7
  * Add libaudit-dev as a build dependency
  * Build perf with NO_LIBPYTHON=1 to avoid a python build dependency.
  * [Config] Remove CONFIG_SATA_AHCI annotation

  [ Ubuntu: 3.8.0-5.10 ]

  * Release Tracking Bug
    - LP: #1118568
  * Bump ABI to fix install issue with 3.8.0-4.8.
    Moving drivers/ata/*ahci* to linux-image caused an
    install conflict with linux-image-extras without an
    ABI bump.
  * SAUCE: xen-pciback: rate limit error messages from
    xen_pcibk_enable_msi{, x}()
    - LP: #1117336
    - CVE-2013-0231

 -- Andy Whitcroft <apw@canonical.com>  Mon, 11 Feb 2013 18:22:23 +0000
